︠7000ed73-54fa-4729-a97a-5644e5b32755i︠
%md
# 2D Graphics in Sage -- Matlab style

Sage also fully supports a library called `matplotlib`, which has an interface closely inspired by MATLAB™.

## [Many Pylab examples...](https://matplotlib.org/gallery/index.html#pyplot)
︡0dc47989-386a-4306-b513-53717dda5028︡{"done":true,"md":"# 2D Graphics in Sage -- Matlab style\n\nSage also fully supports a library called `matplotlib`, which has an interface closely inspired by MATLAB™.\n\n## [Many Pylab examples...](https://matplotlib.org/gallery/index.html#pyplot)"}
︠7df9170a-57db-45d9-ac1c-b326ffe19533s︠
%auto
import numpy as np
import matplotlib.pyplot as plt
︡65436bfc-96eb-4ad4-b49e-8e56aa3d66f4︡{"done":true}︡
︠c1e2c984-c3e4-4c3c-bb40-f4a03a02d83cs︠
plt.plot([1,2,3], [4,5,7], )
plt.show()
︡a8b3baea-6cfe-462d-bfba-25ca5379c693︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7fb7319c9390>]\n"}︡{"file":{"filename":"f529b100-4d43-40e3-bea9-b35ae85f40dd.svg","show":true,"text":null,"text":null,"uuid":"8b944f3c-43d7-43f4-ba70-0826b05b89f4"},"once":false}︡{"done":true}︡
︠32478531-848d-42e4-abe5-7003dfca019d︠
# We put the code from the example in a function, to avoid printing intermediate results.

def example():
    def f(t):
        return np.exp(-t) * np.cos(2*np.pi*t)

    t1 = np.arange(0.0, 5.0, 0.1)
    t2 = np.arange(0.0, 5.0, 0.02)

    plt.figure(1)
    plt.subplot(211)
    plt.plot(t1, f(t1), 'bo', t2, f(t2), 'k')

    plt.subplot(212)
    plt.plot(t2, np.cos(2*np.pi*t2), 'r--')
    plt.show()

# Now draw the plot.
example()
︡e1cdfaea-46ee-4e31-bf45-17c3f8768d3a︡{"file":{"filename":"addaa1e7-dbb3-4298-8966-3859ef02d07d.svg","show":true,"text":null,"uuid":"2a1d1996-fee9-437d-b8e0-74498c79eb2b"},"once":false}︡{"done":true}︡
︠0fba9cc5-819b-4e3d-9fe0-986a7ea6483e︠

︡e32e4913-41f1-4842-83eb-6721fe75214d︡
︠565e0d64-bb88-406a-9928-566c32d19a4di︠
%md
Copy and paste something below.
You can highlight a block, then hit tab to indent the whole thing at once...
︡16d9e1a1-8f37-4613-aee9-48b1e4e5f132︡{"done":true,"md":"Copy and paste something below. \nYou can highlight a block, then hit tab to indent the whole thing at once..."}
︠77f5936f-86c3-4c12-866a-72533200534b︠

def example():
    t = np.arange(0.0, 2.0, 0.01)
    s = np.sin(2*np.pi*t)

    plt.plot(t,s)
    plt.title(r'$\alpha_i > \beta_i$', fontsize=20)
    plt.text(1, -0.6, r'$\sum_{i=0}^\infty\,\, x_i$', fontsize=20)
    plt.text(0.6, 0.6, r'$\mathcal{A}\mathrm{sin}(2 \omega t)$',
             fontsize=20)
    plt.xlabel('time (s)')
    plt.ylabel('volts (mV)')
    plt.show()

example()
︡35db0e5c-e835-461c-8468-f66e31e48f77︡{"file":{"filename":"482727d9-ee6a-457a-b8b0-3ee72dc0656c.svg","show":true,"text":null,"uuid":"e08af1f9-30e7-40a9-9273-f7cde8dacd00"},"once":false}︡{"done":true}︡
︠320e2b4b-b1c5-4d4b-b599-ac9a8a01b485i︠
%md
You can also just directly use Octave, which is a MATLAB clone.

Use `%plot -f svg` to set octave to use nice looking SVG graphics.
︡531fef1e-4210-4117-9ffe-4989ef9fce15︡{"done":true,"md":"You can also just directly use Octave, which is a MATLAB clone.\n\nUse `%plot -f svg` to set octave to use nice looking SVG graphics."}
︠7dfdee1e-3359-48ad-a1ff-595f4ee4bf6as︠
%octave
%plot -f svg -s 800,600
plot([1,2,3], [4,5,7])
set(gca, "fontsize", 16)
︡5e0dfdf3-bfe2-4dde-a403-5590dadd2728︡{"file":{"filename":"/tmp/tmpIzw00s.svg","show":false,"text":null,"uuid":"57c74dc4-ed32-4c84-b4b0-fc12472cd96b"},"once":false}︡{"html":"<img src=\"/blobs//tmp/tmpIzw00s.svg?uuid=57c74dc4-ed32-4c84-b4b0-fc12472cd96b\" smc-image-scaling=\"1\" />"}︡{"done":true}︡
︠c8869624-dcfd-4eba-a278-285db2da5272s︠
%octave
x = 0:0.01:20;
y = (1 + sqrt(x)) .* sin (x);
plot (x, y);
set(gca, "fontsize", 16);
xlabel ("x");
ylabel ("(1 + sqrt(x)) * sin (x)");
title ("Simple 2-D Plot");
︡fbbad71a-f233-4da3-83b0-1a346cda5941︡{"file":{"filename":"/tmp/tmpJtmduo.svg","show":false,"text":null,"uuid":"6bdd6ddf-1569-4313-ba60-cd9407943235"},"once":false}︡{"html":"<img src=\"/blobs//tmp/tmpJtmduo.svg?uuid=6bdd6ddf-1569-4313-ba60-cd9407943235\" smc-image-scaling=\"1\" />"}︡{"done":true}︡
︠8676f430-3efc-45b7-b3c8-2320f2364049s︠


import numpy as np
import matplotlib.pyplot as plt

fig = plt.figure()
ax = fig.add_subplot(111, polar=True)
r = np.arange(0,1,0.001)
theta = 2 * 2*np.pi * r
line, = ax.plot(theta, r, color='#ee8d18', lw=3)

ind = 800
thisr, thistheta = r[ind], theta[ind]
ax.plot([thistheta], [thisr], 'o')
ax.annotate('a polar annotation',
            xy=(thistheta, thisr),  # theta, radius
            xytext=(0.05, 0.05),    # fraction, fraction
            textcoords='figure fraction',
            arrowprops=dict(facecolor='black', shrink=0.05),
            horizontalalignment='left',
            verticalalignment='bottom',
            )
plt.show()
︡f994ee67-aa82-4b89-9e5d-755f566668de︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7fb7318d1590>]\n"}︡{"stdout":"<matplotlib.text.Annotation object at 0x7fb7318d1850>\n"}︡{"file":{"filename":"c09b9e6d-f477-4f61-bed2-fea7646b0114.svg","show":true,"text":null,"uuid":"c2dd9748-0958-45de-9772-bb6d12476f62"},"once":false}︡{"done":true}︡
︠910cbeaa-efbf-4ab3-b679-95ced7af954f︠









